var expect = require('chai').expect;
require('chai').should();

describe('Array', function() {
  describe('#indexOf', function() {
    it('should return -1 when the value is not present', function() {
      [1,2,3].indexOf(5).should.equal(-1);
    });

    it('should return the index when the value is present', function() {
      [1,2,3].indexOf(3).should.equal(2);
    });

    it('should return the index when the value is present again', function() {
      [1,2,3].indexOf(3).should.equal(9);
    });
  });
});

describe("Array", function() {
  describe("length", function() {
    it("should have a length of 3", function() {
      var arr = [1,2,3];
      arr.length.should.equal(3);
    });
    it("should have a length of 0 for an empty array", function() {
      var arr = [];
      arr.length.should.equal(0);
    });
    it('should have a length of 1', function() {
      var arr = [1];
      arr.length.should.equal(1);
    })
    it('should have a length of 1 with expect', function() {
      var arr = [1];
      expect(arr.length).to.equal(1);
    })
  });
});

describe('Async func', function() {
  it('should be async', function(done) {
    asyncFun(function(err) {
      if(err) throw err;
      done();
    });
  });
  it('should be async with done', function(done) {
    asyncFun(done);
  });
});

function asyncFun(callback) {
  setTimeout(callback, 1000);
}
